/*********************************************************************
 *	USBoR̃^[Qbg[ANZX
 *********************************************************************
 *API:
int		UsbInit(int verbose,int enable_bulk, char *serial);			.
int		UsbExit(void);												I.
void 	UsbBench(int cnt,int psize);					x`}[N

void 	UsbPoke(int adr,int arena,int data,int mask);	
int 	UsbPeek(int adr,int arena);						1oCgǂݏo
int 	UsbRead(int adr,int arena,uchar *buf,int size);	Aǂݏo
void	UsbDump(int adr,int arena,int size);			[_v
 *
 *֐:
void	dumpmem(int adr,int cnt);
void	pokemem(int adr,int data0,int data1);
void	memdump_print(void *ptr,int len,int off);
 */

#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "hidasp.h"
#include "monit.h"
#include "portlist.h"
#include "util.h"
#include "../firmware/hidcmd.h"

#define	VERBOSE	0

#define	if_V	if(VERBOSE)

static	char verbose_mode = 0;
static  int  HidLength1 = 7;
static  int  HidLength  = 31;

// ReportID:4  POLLING PORTςł.
static	int	pollcmd_implemented;

//	ی|[g
#define	PROTECTED_PORT_MAX	3
static	int	protected_ports[PROTECTED_PORT_MAX]={-1,-1,-1};
#define	PROTECTED_PORT_MASK	0x38	// 0011_1000


#define	ID4		4
#define	LENGTH4	5


/****************************************************************************
 *	[e_v.
 ****************************************************************************
 *	void *ptr : _vf[^.
 *	int   len : _voCg.
 *	int   off : ^[Qbg̔Ԓn\.
 */
void memdump_print(void *ptr,int len,int off)
{
	unsigned char *p = (unsigned char *)ptr;
	int i,j,c;

	for(i=0;i<len;i++) {
		if( (i & 15) == 0 ) printf("%06x",(int)p - (int)ptr + off);
		printf(" %02x",*p);p++;
		if( (i & 15) == 15 )
		{
#if	1	// ASCII DUMP
			printf("  ");
			for(j=0;j<16;j++) {
				c=p[j-16];
				if(c<' ') c='.';
				if(c>=0x7f) c='.';
				printf("%c",c);
			}
#endif
			printf("\n");
		}
	}
	printf("\n");
}



/*********************************************************************
 *	AVRfoCXɏR}h𑗂āAKvȂ猋ʂ󂯎.
 *********************************************************************
 *	cmdBuf   *cmd : R}h
 *	uchar    *buf : ʂ󂯎̈.
 *  int reply_len : ʂ̕KvTCY. (0̏ꍇ͌ʂ󂯎Ȃ)
 *߂l
 *		0	: s
 *	   !0   : 
 */
int QueryAVR(cmdBuf *cmd,uchar *buf,int reply_len)
{
	int rc = 0;
	int report_id = cmd->report_id;
	int size = cmd->size;
	char *s;
	rc = hidWriteBuffer((char*) cmd , HidLength1 );
	if(rc == 0) {
		printf("hidWrite error\n");
		exit(1);
	}
	if(reply_len) {
		rc = hidReadBuffer((char *)cmd , reply_len );
		if(rc == 0) {
			if(report_id != 4) {
				printf("hidRead error %d\n",report_id);
				exit(1);
			}
		}
		s = (char*) cmd;
		memcpy(buf, s+1 ,size);
	}
    return rc;
}
/*********************************************************************
 *	^[Qbg̃[e擾
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           size :ǂݎTCY.
 *	unsigned char *buf :󂯎obt@.
 *	: HID Report Length - 1 蒷TCY͗vĂ͂ȂȂ.
 */
int dumpmem(int adr,int arena,int size,unsigned char *buf)
{
	cmdBuf cmd;

	memset(&cmd,0,sizeof(cmdBuf));
	cmd.cmd   = CMD_PEEK ;	//| arena;
	cmd.size  = size;
	cmd.adr[0]= adr;
	cmd.adr[1]= adr>>8;

	if( QueryAVR(&cmd,buf,1+size) == 0) return 0;	//s.
	return size;
}
/*********************************************************************
 *	^[Qbg̃[e(1oCg).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int          data0 :݃f[^.      (OR)
 *	int          data1 :݃rbg}XN.(AND)
 *:
 *	t@[̏݃ASY͈ȉ̂悤ɂȂĂ̂Œ.

	if(data1) {	//}XNt̏.
		*adr = (*adr & data1) | data0;
	}else{			//ׂ.
		*adr = data0;
	}

 */
int	pokemem(int adr,int arena,int data0,int data1)
{
    cmdBuf cmd;
	char buf[16];	// dummy

	memset(&cmd,0,sizeof(cmdBuf));
	cmd.cmd   = CMD_POKE ;	//| arena;
	cmd.size  = 1;
	cmd.adr[0]= adr;
	cmd.adr[1]= adr>>8;
	cmd.data[0] = data0;
	cmd.data[1] = data1;
	return QueryAVR(&cmd,buf,0);
}

/*********************************************************************
 *	^[QbgƂ̐ڑ`FbN(x`}[N˂)
 *********************************************************************
 *	int i : 0`255 ̐l.
 *߂l
 *		GR[obNꂽ i ̒l.
 */
int hid_ping(int i)
{
 	cmdBuf cmd;
	char buf[128];	// dummy
	int rc;

	memset(&cmd,i,sizeof(cmdBuf));
	cmd.cmd   = CMD_PING ;
	QueryAVR(&cmd,buf,0);

	rc = hidReadBuffer(buf , HidLength );
	if(rc == 0) {
		printf("hidRead error\n");
		exit(1);
	}
	return buf[2] & 0xff;
}
/*********************************************************************
 *	]xx`}[N
 *********************************************************************
 *	int cnt  : PINGł.
 *	int psize: PINGpPbg̑傫(݂̓T|[gȂ)
 */
void UsbBench(int cnt,int psize)
{
	int i,n,rc;
	int time1, rate;
	long long total=0;
	int nBytes  = HidLength1 + HidLength ;	//݌Œ.
	// 1Ping 7byteQuery31oCg̃^[.

   	printf("hid write start\n");
	int time0 = clock();

	for(i=0;i<cnt;i++) {
		n = i & 0xff;
		rc = hid_ping(n);
		if(rc != n) {
			printf("hid ping mismatch error (%x != %x)\n",rc,n);
			exit(1);
		}
		total += nBytes;
	}

	time1 = clock() - time0;
	if (time1 == 0) {
		time1 = 2;
	}
	rate = (int)((total * 1000) / time1);

	if (total > 1024*1024) {
	   	printf("hid write end, %8.3lf MB/%8.2lf s,  %6.3lf kB/s\n",
	   		(double)total/(1024*1024), (double)time1/1000, (double)rate/1024);
	} else 	if (total > 1024) {
	   	printf("hid write end, %8.3lf kB/%8.2lf s,  %6.3lf kB/s\n",
	   		 (double)total/1024, (double)time1/1000, (double)rate/1024);
	} else {
	   	printf("hid write end, %8d B/%8d ms,  %6.3lf kB/s\n",
	   		(int)total, time1, (double)rate/1024);
   	}
}
/*********************************************************************
 *	^[Qbg[_v.
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int            cnt :ǂݎTCY.
 */
void UsbDump(int adr,int arena,int cnt)
{
	unsigned char buf[16];
	int size;
	int rc;
	while(cnt) {
		size = cnt;
		if(size>=8) size = 8;
		rc = dumpmem(adr,arena,size,buf);	//[e̓ǂݏo.

		if(rc !=size) return;
		memdump_print(buf,size,adr);		//ʈ.
		adr += size;
		cnt -= size;
	}
}
/*********************************************************************
 *	^[Qbg[Aǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	uchar         *buf :ǂݎobt@.
 *	int           size :ǂݎTCY.
 *߂l
 *	-1    : s
 *	̒l: .
 */
int UsbRead(int adr,int arena,uchar *buf,int size)
{
	int rc = size;
	int len;
	while(size) {
		len = size;
		if(len >= 8) len = 8;
		int rc = dumpmem(adr,arena,len,buf);
		if( rc!= len) {
			return -1;
		}
		adr  += len;	// ^[QbgAhXi߂.
		buf  += len;	// ǂݍݐobt@i߂.
		size -= len; 	// cTCY炷.
	}
	return rc;
}
/*********************************************************************
 *	^[Qbg[1oCgǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbPeek(int adr,int arena)
{
	unsigned char buf[16];
	int size=1;
	int rc = UsbRead(adr,arena,buf,size);
	if( rc != size) {
		return -1;
	}
	return buf[0];
}

static	int	poll_port = 0;

/*********************************************************************
 *	^[Qbg[1oCgAǂݏõZbgAbv
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbSetPoll_slow(int adr,int arena)
{
	poll_port = adr;
	return 1;
}
/*********************************************************************
 *	^[Qbg[1oCgAǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbPoll_slow()
{
	return UsbPeek(poll_port,0);
}

/*********************************************************************
 *	^[Qbg[1oCgAǂݏõZbgAbv
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbSetPoll(int adr,int arena)
{
	char buf[128];
	char rd_buf[128];

	if( pollcmd_implemented == 0 ) {
		return UsbSetPoll_slow(adr,arena);
	}

	memset(buf,0,sizeof(buf));

	buf[0] = ID4;
	buf[1] = CMD_SETPAGE;
	buf[2] = 0;		// page_mode
	buf[3] = adr;	// page_addr
	buf[4] = adr>>8;// page_addr_h

	if( QueryAVR( (cmdBuf*) buf, rd_buf , 0) == 0) return 0;	//s.
	return 1;
}
/*********************************************************************
 *	^[Qbg[1oCgAǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbPoll()
{
	char buf[128];	// dummy
	int rc;

	if( pollcmd_implemented == 0 ) {
		return UsbPoll_slow();
	}

	rc = hidReadPoll(buf , LENGTH4 ,ID4);
	if(rc == 0) {
#if	0
		printf("hidRead error\n");
		exit(1);
#else
		return -1;
#endif
	}
	return buf[1] & 0xff;
}


int UsbAnalogPoll(int mode,unsigned char *abuf)
{
	hidCommand(HIDASP_SET_PAGE,mode,0,0);	// Set Page mode
	if(mode == 0xa2) {
		Sleep(3);
	}
	int rc = hidReadPoll(abuf , LENGTH4 ,ID4);
//	Sleep(100);
	return rc;
}



/*********************************************************************
 *	^[Qbg̃[e(1oCg).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           data :݃f[^.
 *	int           mask :ݗLrbg}XN.
 *
 *  mask  = 0 ̏ꍇ͑SrbgL ()
 *	mask != 0 ̏ꍇ́Amaskrbg1ɑΉdatâݍXVA͕ύXȂ.
 */
int	usbPoke(int adr,int arena,int data,int mask)
{
	int data0 ,data1;
	if(mask == 0) {
		// }XNsv̒.
		data0 = data;
		data1 = 0;
	}else{
		// }XN܂ޏ.
		// ݃f[^̗L mask ̃rbg 1 ɂȂĂ镔̂.
		// mask ̃rbg 0 ł镔́Ȁێ.

		data0 = data & mask;	// OR.
		data1 = 0xff &(~mask);	// AND.

		// }XÑ݂WbN͈ȉ.
		// *mem = (*mem & data1) | data0;
	}

	return pokemem(adr,arena,data0,data1);
}
/*********************************************************************
 *	^[Qbg̃[e(1oCg).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           data :݃f[^.
 *	int           mask :ݗLrbg}XN.
 *
 *  mask  = 0 ̏ꍇ͑SrbgL ()
 *	mask != 0 ̏ꍇ́Amaskrbg1ɑΉdatâݍXVA͕ύXȂ.
 */
int UsbPoke(int adr,int arena,int data,int mask)
{
	int i;
	int f=0;
	for(i=0;i<PROTECTED_PORT_MAX;i++) {
		if(adr == protected_ports[i]) f=1;
	}

	if(f==0) return usbPoke(adr,arena,data,mask);

	if(mask==0) mask = 0xff;
	mask &= ~PROTECTED_PORT_MASK;	// USB D+,D-,PULLUP rbg̏}XN.
	data &= ~PROTECTED_PORT_MASK;

	if(adr == protected_ports[0]) { mask = 0;}	// pind mask writeĂ͂Ȃ.

	return usbPoke(adr,arena,data,mask);
}
/*********************************************************************
 *	1rbg̏
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int            bit :݃f[^(1bit) 0  1
 *	int           mask :ݗLrbg}XN.
 */
void UsbPoke_b(int adr,int arena,int bit,int mask)
{
	int data=0;
	if(mask == 0) {
		//1oCg̏.
		UsbPoke(adr,arena,bit,0);
	}else{
		//1rbg̏.
		if(bit) data = 0xff;
		UsbPoke(adr,arena,data,mask);
	}
}

/*********************************************************************
 *
 *********************************************************************
 */
void local_init(void)
{
	protected_ports[0]=portAddress("pind");
	protected_ports[1]=portAddress("portd");
	protected_ports[2]=portAddress("ddrd");
}
/*********************************************************************
 *
 *********************************************************************
 */
void UsbCheckPollCmd(void)
{
	pollcmd_implemented = 1;			// Ƃ肠ĂƉ.
	{
		int gtccr = portAddress("gtccr");	// LSB̂10̃|[g.
		int data;
		int rc = UsbSetPoll(gtccr,0);
		if(rc==0) {					// s.
			pollcmd_implemented = 0;		// ĂȂƔ.
			return ;
		}

		data = UsbPoll();
		if((data == (-1)) || (data & 0xfe)) {
			pollcmd_implemented = 0;		// ĂȂƔ.
		}
	}
}

/*********************************************************************
 *	
 *********************************************************************
 */
int UsbInit(int verbose,int enable_bulk, char *serial)
{
	verbose_mode = verbose;
	if(	hidasp_init(serial) & HIDASP_MODE_ERROR) {
    	printf("error: [%s] device not found!\n", serial);
    	Sleep(1000);
    	return 0;
	} else {
		local_init();
		UsbCheckPollCmd();
		return 1;	// OK.
	}
}

/*********************************************************************
 *	I
 *********************************************************************
 */
int UsbExit(void)
{
	hidasp_close();
	return 0;
}
